#-*- coding: utf-8 -*-
from RecordTimer import RecordTimerEntry, RecordTimer, parseEvent, AFTEREVENT
from Components.UsageConfig import preferredTimerPath, preferredInstantRecordPath
from Components.config import config
from Screens.MessageBox import MessageBox
from ServiceReference import ServiceReference
import os

# --> SkyTimerRec
class SkyTimerRec():

	#def __init__(self):
	#	pass
	
	@staticmethod	
	def addTimer(session, serviceref, begin, end, name, description, disabled, justplay, afterevent, dirname, tags, repeated, logentries=None, eit=0):
	
		#<timer begin="1359306420" end="1359308160" serviceref="1:0:19:EF75:3F9:1:C00000:0:0:0:" repeated="0" name="Die Simpsons" description="Die Simpsons" afterevent="auto" eit="9206" location="/hdd/movie/" tags="" disabled="0" justplay="0">
	
		rt = session.nav.RecordTimer
		print "mao1", dirname
		
		msgTimeout = config.plugins.skyanytime.msgtimeout.value
		dirname = config.plugins.skyanytime.anytimefolder.value
		
		if not dirname:
			dirname = preferredTimerPath()
	
		print "mao2", dirname
			
		try:
			timer = RecordTimerEntry(
				ServiceReference(serviceref),
				begin,
				end,
				name,
				description,
				eit,
				disabled,
				justplay,
				afterevent,
				dirname=dirname,
				tags=tags)
	
			timer.repeated = repeated
	
			if logentries:
				timer.log_entries = logentries
				print "rrgggg"
				
			conflicts = rt.record(timer)
			if conflicts:
				errors = []
				for conflict in conflicts:
					errors.append(conflict.name)
	
				print "duuuupppppppeeeeee"
				return {
					"result": False,
					"message": "Conflicting Timer(s) detected! %s" % " / ".join(errors)
				}
		except Exception, e:
			print "adupppeee"
			print e
			return {
				"result": False,
				"message": "Could not add timer '%s'!" % name
			}
			
		print "[skyanytime] timer added."
		if config.plugins.skyanytime.silent_timer_mode.value == False:
			message = session.open(MessageBox, _("%s - %s added.\nTarget: %s") % (name, description, dirname), MessageBox.TYPE_INFO, timeout=msgTimeout)
		
		return {
			"result": True,
			"message": "Timer '%s' added" % name
		}
